
CoCoA-5 - Bug #1100

PrimaryDecomposition0: says not 0-dim but IsZeroDim says ideal is zero-dim!

11 Sep 2017 14:39 - John Abbott

Status: Closed Start date: 11 Sep 2017

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: enhancing/improving Estimated time: 1.01 hour

Target version: CoCoA-5.2.2 Spent time: 1.65 hour

Description

Bug summarized in this transcript

/**/ L:=[3*x^3*y +3*y*z^3 +1,  2*x*y*z^2 +3*x,  2*y^3*z +1];

/**/ I := ideal(L);

/**/ IsZeroDim(I);

true

/**/ PrimaryDecomposition0(I);

--> ERROR: IsPrimary: implemented only for 0-dimensional ideals

--> WHERE: at line 20 (column 5) of maximal.cpkg5

-->     error("IsPrimary: implemented only for 0-dimensional ideals");

-->     ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

CONTEXT: function IsPrimary at line 20 of maximal.cpkg5

 CALLED BY: function PrimaryDecomposition0 at line 38 of PrimaryDecomposition0.cpkg5

  called at top-level

Related issues:

Related to CoCoALib - Bug #1101: Bug in MinPolyModular (insufficient rational... Closed 11 Sep 2017

History

#1 - 11 Sep 2017 18:21 - Anna Maria Bigatti

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 10

With SetVerbosity(90) it appears that down in the recursion it get an ideal=(1).

Investigating (should never happen!)

#2 - 11 Sep 2017 18:40 - Anna Maria Bigatti

Found it: we knew it could happen, and this is the first time I see it!

The modular reconstruction gives the wrong minimal polynomial (may happen, of course).

That fact can be easily detected when one of the ideals I+ideal(factor) = 1.

In fact we never checked that the evaluation of the minpoly is in I!

I'll add this check to the code of MinPolyModular  (this is in CoCoALib).

#3 - 11 Sep 2017 19:12 - Anna Maria Bigatti

- Related to Bug #1101: Bug in MinPolyModular (insufficient rational reconstruction) added

#4 - 11 Sep 2017 19:19 - Anna Maria Bigatti

27 Apr 2024 1/2



- Status changed from New to Feedback

- % Done changed from 10 to 90

- Estimated time set to 1.01 h

Fixed: was a problem in MinPolyModular.

#5 - 12 Sep 2017 12:20 - John Abbott

Anna: have you added the example(s) as a tests cases in the CoCoA test suite?

#6 - 12 Sep 2017 13:43 - John Abbott

Here is a zero-dim ideal with primdecomp having 32 components:

 I := ideal(x^4 +x^2 +1,  y^4 +y,  z^4 +z);

 

Might be useful sooner or later?

#7 - 11 Dec 2017 17:53 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

added tests

closing
